var currentBlock = ('.wrapper p');
var menuIsOpen = false;


// functions for changing blocks
var castToHistory = function(){
	var element = getCurrentBlock();
	var elementAbove = getCurrentBlock().prev();
	element.replaceWith('<p class="bold" contenteditable="true">History</p>');
	elementAbove.next().focus();
	addNewBlockBelow();
}

var castToExamine = function(){
	var element = getCurrentBlock();
	var elementAbove = getCurrentBlock().prev();
	element.replaceWith('<p class="bold" contenteditable="true">Examination</p>');
	elementAbove.next().focus();
	addNewBlockBelow();
}

var castToPlan = function(){
	var element = getCurrentBlock();
	var elementAbove = getCurrentBlock().prev();
	element.replaceWith('<p class="bold" contenteditable="true">Plan</p>');
	elementAbove.next().focus();
	addNewBlockBelow();
}

var castToScript = function(){
	var element = getCurrentBlock();
	var elementAbove = getCurrentBlock().prev();
	element.replaceWith('<p class="script" contenteditable="true"  placeholder="Enter medication"></p>');
	elementAbove.next().focus();
}

var castToTest = function(){
	var element = getCurrentBlock();
	var elementAbove = getCurrentBlock().prev();
	element.replaceWith('<p class="script test" contenteditable="true"  placeholder="Enter lab test"></p>');
	elementAbove.next().focus();
}


var commands = [
	{name: 'History', func: castToHistory},
	{name: 'Examination', func: castToExamine},
	{name: 'Plan', func: castToPlan},
	{name: 'Add prescription', func: castToScript},
	{name: 'Add lab test', func: castToTest},
]

var filteredCommands;
var selectedCommand = 1;



function addNewBlockBelow(){
	$('<p contenteditable="true" placeholder="Type / to show commands"  oninput="textEntered()"></p>').insertAfter(getCurrentBlock());
    var nextBlock = getCurrentBlock().next();
    getCurrentBlock().next().focus();
}




function getCurrentBlock(){
	var el = document.activeElement;
	return $(el);
}

function addScript(){
	var element = getCurrentBlock();
	var elementAbove = getCurrentBlock().prev();
	element.replaceWith('<p class="script" contenteditable="true">Enter prescription</p>');
	elementAbove.next().focus();
}



function moveFocusDown(){
	getCurrentBlock().next().focus();
}

function moveFocusUp(){
	getCurrentBlock().prev().focus();
}

function textEntered(){
	var currentText = getCurrentBlock().html();
	currentText = currentText.substring(1).toLowerCase();

	filteredCommands = $.grep( commands, function( o, i ) {
	  var text = o.name.toLowerCase();
	  return text.includes(currentText);
	});

	selectedCommand = 1;
	renderMenu();
}

function renderMenu(){
	$('#menu').empty();

	for (var o of filteredCommands) {
		$('#menu').append('<p>' + o.name + '</p>')  
	}

	$('#menu p:nth-child(' + selectedCommand +  ')').addClass('active');
}


document.addEventListener('keydown', function(event) {
	    if(event.keyCode == 191) {
	        console.log('slash was pressed');

	        // open menu
	    	position = getCurrentBlock().offset();
	    	position.top += 25;
	    	$('#menu').css(position)
	    	$('#menu').css('opacity', '1');
	    	menuIsOpen = true;
	    }

	    if(event.keyCode == 13) {
	        console.log('enter was pressed');
	        event.preventDefault();

	        if(!menuIsOpen){
	        	
	        	// Is this block static?
	        	if(getCurrentBlock().hasClass('static')){
	        		moveFocusDown();
	        		// if nothing is underneath we should make something however
	        	}else{
	        		// Make a new text block
	        		addNewBlockBelow();
	        	}
				
	        
	        }else{
	        	// do whats in the menu
	        	filteredCommands[selectedCommand-1].func();
	        }

	        // hide menu
	        $('#menu').css('opacity', '0');
	        menuIsOpen = false;
    
	    }


	    if(event.keyCode == 8) {
	        console.log('backspace was pressed');

	        // BUGS
	        // cursor goes to start of block not back
	        // if you delete the last bit of non static content your screwed

	        // if the block is empty, delete it
	        if(getCurrentBlock().html().length == 0 && !getCurrentBlock().hasClass('static')){
	        	var parent = getCurrentBlock().prev();
	        	getCurrentBlock().remove();
	        	parent.focus();
	        }
	    }

	    if(event.keyCode == 38) {
	        console.log('up arrow was pressed');
	        if(menuIsOpen){
	        	event.preventDefault();
	        	selectedCommand--;
	        	renderMenu();
	        	return;
	        }

	        moveFocusUp();
	    }

	    if(event.keyCode == 40) {
	        console.log('down arrow was pressed');
	        if(menuIsOpen){
	        	event.preventDefault();
	        	selectedCommand++;
	        	renderMenu();
	        	return;
	        }
	        
	        moveFocusDown();
	    }
	    
});